-- A bit ugly, we want the talent frame to display a dialog box in certain conditions.
function PortraitFrameCloseButton_OnClick(self)
	if ( self:GetParent().onCloseCallback) then
		self:GetParent().onCloseCallback(self);
	elseif ( IsOnGlueScreen() ) then
		self:GetParent():Hide();
	else
		HideParentPanel(self);
	end
end

function InputBoxInstructions_OnLoad(self)
	Mixin(self.Instructions, SetShownMixin);
	self:SetFontObject(GameFontHighlightSmall);
	self.enabled = true;
	function self:Enable() self:SetEnabled(true); end
	function self:Disable() self:SetEnabled(false); end
	function self:IsEnabled() return self.enabled; end
	function self:SetEnabled(enabled)
		enabled = enabled and true or false;
		if self.enabled ~= enabled then
			self.enabled = enabled;
			self:EnableKeyboard(enabled);
			self:ClearFocus();
			local script = self:GetScript(self.enabled and "OnEnable" or "OnDisable");
			if script then
				script(self);
			end
		end
	end
end

function InputBoxInstructions_OnTextChanged(self)
    self.Instructions:SetShown(self:GetText() == "")
end

function InputBoxInstructions_UpdateColorForEnabledState(self, color)
	if color then
		self:SetTextColor(color:GetRGBA());
	end
end

function InputBoxInstructions_OnDisable(self)
	InputBoxInstructions_UpdateColorForEnabledState(self, self.disabledColor);
end

function InputBoxInstructions_OnEnable(self)
	InputBoxInstructions_UpdateColorForEnabledState(self, self.enabledColor);
end

function InputBoxInstructions_OnEditFocusGained(self)
	if not self:IsEnabled() then
		self:ClearFocus();
	end
end

-- functions to manage tab interfaces where only one tab of a group may be selected
local function GetTabByIndex(frame, index)
	return frame.Tabs and frame.Tabs[index] or _G[frame:GetName().."Tab"..index];
end

function PanelTemplates_ResizeTabsToFit(frame, maxWidthForAllTabs)
	local selectedIndex = PanelTemplates_GetSelectedTab(frame);
	if ( not selectedIndex ) then
		return;
	end

	local currentWidth = 0;
	local truncatedText = false;
	for i = 1, frame.numTabs do
		local tab = GetTabByIndex(frame, i);
		currentWidth = currentWidth + tab:GetWidth();
		--[[
		if not tab.Text then tab.Text = _G[tab:GetName().."Text"]; end
		if not tab.Text.IsTruncated then Mixin(tab.Text, IsTruncatedMixin); end
		if tab.Text:IsTruncated() then
			truncatedText = true;
		end
		]]
	end
	if ( not truncatedText and currentWidth <= maxWidthForAllTabs ) then
		return;
	end

	local currentTab = GetTabByIndex(frame, selectedIndex);
	PanelTemplates_TabResize(currentTab, 0);
	local availableWidth = maxWidthForAllTabs - currentTab:GetWidth();
	local widthPerTab = availableWidth / (frame.numTabs - 1);
	for i = 1, frame.numTabs do
		if ( i ~= selectedIndex ) then
			local tab = GetTabByIndex(frame, i);
			PanelTemplates_TabResize(tab, 0, widthPerTab);
		end
	end
end

MaximizeMinimizeButtonFrameMixin = {};

function MaximizeMinimizeButtonFrameMixin:OnShow()
	if self.cvar then
		local minimized = ezCollections:GetCVarBool(self.cvar);
		if minimized then
			self:Minimize();
		else
			self:Maximize();
		end
	end
end

function MaximizeMinimizeButtonFrameMixin:SetMinimizedCVar(cvar)
	self.cvar = cvar;
end

function MaximizeMinimizeButtonFrameMixin:SetOnMaximizedCallback(maximizedCallback)
	self.maximizedCallback = maximizedCallback;
end

function MaximizeMinimizeButtonFrameMixin:Maximize()
	if self.maximizedCallback then
		self.maximizedCallback(self);
	end

	if self.cvar then
		ezCollections:SetCVar(self.cvar, false);
	end
	
	self.MaximizeButton:Hide();
	self.MinimizeButton:Show();
end

function MaximizeMinimizeButtonFrameMixin:SetOnMinimizedCallback(minimizedCallback)
	self.minimizedCallback = minimizedCallback;
end

function MaximizeMinimizeButtonFrameMixin:Minimize()
	if self.minimizedCallback then
		self.minimizedCallback(self);
	end
	
	if self.cvar then
		ezCollections:SetCVar(self.cvar, true);
	end
	
	self.MaximizeButton:Show();
	self.MinimizeButton:Hide();
end

function MaximizeMinimizeButtonFrameMixin_OnLoad(self)
	Mixin(self, MaximizeMinimizeButtonFrameMixin);
	self:SetScript("OnShow", self.OnShow);
end
